# -*- python -*-
# $RCSfile: skeletonbdyGUI.py,v $
# $Revision: 1.5 $
# $Author: langer $
# $Date: 2004/09/21 19:23:57 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from SWIG.common import ooferror
from common import debug
from common.IO import whoville
from common.IO.GUI import chooser
from common.IO.GUI import parameterwidgets
from common.IO.GUI import whowidget
from engine import skeletoncontext
from engine.IO import skeletonbdydisplay

import traceback
# Widget for the skeleton boundary parameter.  Does clever things
# with scopes to resolve the correct graphics window, for finding the
# right skeleton, to get the boundary lists.
class SkeletonBoundaryParamWidget(parameterwidgets.ParameterWidget,
                                  chooser.MultiListWidget):
    def __init__(self, param, scope):
        # Find the who widget with the skeleton.
        self.skelwidget = scope.findWidget(
            lambda x: isinstance(x, whowidget.WhoWidget)
            and x.whoclass is skeletoncontext.skeletonContexts)

        # Use it to get the context or proxy.
        skelname = self.skelwidget.get_value()
        skelctxt = skeletoncontext.skeletonContexts[skelname]
        if issubclass(skelctxt.__class__, whoville.WhoProxy):
            gfxwindow = scope.findData("gfxwindow")
            if gfxwindow is None:
                raise ooferror.ErrUserError("Unable to find a Skeleton or its list of boundaries!")
            skelctxt = skelctxt.resolve(gfxwindow)

        bdynames = skelctxt.edgeboundaries.keys() + \
                   skelctxt.pointboundaries.keys()
        chooser.MultiListWidget.__init__(self, objlist=bdynames)
        parameterwidgets.ParameterWidget.__init__(self, self.gtk, scope)
        self.set_value(param.value)

        self._valid = 1 # Always valid.

    
def _make_SBPWidget(self, scope):
    return SkeletonBoundaryParamWidget(self, scope)

skeletonbdydisplay.SkeletonBoundaryParameter.makeWidget = _make_SBPWidget
