# -*- python -*-
# $RCSfile: skeletongroupparams.py,v $
# $Revision: 1.9 $
# $Author: reida $
# $Date: 2004/02/13 21:28:29 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Special parameter types for skeleton groups and boundaries.  They're
# basically strings, but the special parameter type means it can have
# a special widget in the GUI.

from common import utils
from common.IO import parameter
from common.IO.selectionplaceholder import SelectionPlaceHolder
import types


class NodeGroupParameter(parameter.StringParameter): pass

class SegmentGroupParameter(parameter.StringParameter): pass

class ElementGroupParameter(parameter.StringParameter): pass

class BoundaryParameter(parameter.StringParameter): pass


# Another parameter type for specifying "aggregates", which can
# include not only groups, but also the selection.  Subclassing is
# again for the purpose of having special widgets.

class NodeAggregateParameter(parameter.ParameterBase):
    def __init__(self, name, value=None, default=None, tip=None):
        self.checker = parameter.TypeChecker(
            types.StringType, SelectionPlaceHolder)
        parameter.ParameterBase.__init__(
            self, name, value=value, default=default, tip=tip)
        
class SegmentAggregateParameter(parameter.ParameterBase):
    def __init__(self, name, value=None, default=None, tip=None):
        self.checker = parameter.TypeChecker(
            types.StringType, SelectionPlaceHolder)
        parameter.ParameterBase.__init__(
            self, name, value=value, default=default, tip=tip)

class ElementAggregateParameter(parameter.ParameterBase):
    def __init__(self, name, value=None, default=None, tip=None):
        self.checker = parameter.TypeChecker(
            types.StringType, SelectionPlaceHolder)
        parameter.ParameterBase.__init__(
            self, name, value=value, default=default, tip=tip)
