# -*- python -*-
# $RCSfile: meshcrosssection.py,v $
# $Revision: 1.4 $
# $Author: reida $
# $Date: 2004/05/05 20:35:20 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Cross-section objects.  These are the domains of the cross-section
# outputs, and live (indexed by name) inside Mesh objects.  Currently,
# we only have one type, a simple straight-line path between two
# points (defined, obviously, by the two points).  Later, there may be
# others.
import engine.mesh
from common import registeredclass
from common import primitives
from common.IO import parameter

# Anticipating lots of different sorts of these, we make CrossSection
# a registered class.

class MeshCrossSection(registeredclass.RegisteredClass):
    registry = []

class StraightCrossSection(MeshCrossSection):
    # start and end should be primitives.Point objects...
    def __init__(self, start, end):
        self.start = start
        self.end = end

registeredclass.Registration(
    'Straight', MeshCrossSection, StraightCrossSection, 1,
    params=[primitives.PointParameter('start'),
            primitives.PointParameter('end')])
