# -*- python -*-
# $RCSfile: solver_.py,v $
# $Revision: 1.16 $
# $Author: redwing $
# $Date: 2004/09/09 18:01:02 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from common import cregisteredclass
from common import debug
from common.IO import parameter
import SWIG.engine.preconditioner



def _apply(self, meshcontext):
    from SWIG.engine import solverstepper
    equilibrate = solverstepper.SolverStepper(
        self, meshcontext, solverstepper.SolverStepperIterationManager(1))
    equilibrate.precompute()
    equilibrate.iterate()
    equilibrate.short_postcompute()

    


SolverPtr.apply = _apply



cregisteredclass.registerCClass(SolverPtr)


cregisteredclass.Registration("GMRES", SolverPtr, GMRESSolver, ordering=100,
                              params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.IntParameter("krylov_dimension", 100),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("BiCG", SolverPtr, BiCGSolver, ordering=200,
                              params=[
    parameter.IntParameter("max_iterations", 1000),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("CG", SolverPtr, CGSolver, ordering=300,
                              params=[
    parameter.IntParameter("max_iterations",  1000),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("BiCGStab", SolverPtr, BiCGStabSolver, ordering=400,
                              params=[
    parameter.IntParameter("max_iterations",  1000),
    parameter.FloatParameter("tolerance", 1.e-8),
    parameter.Parameter("pc", SWIG.engine.preconditioner.PreconditionerWrapPtr)
    ]
                              )

cregisteredclass.Registration("Direct", SolverPtr, DirectSolver,
                              ordering=1000, params=[] )


from SWIG.engine.preconditioner import PreconditionerWrapPtr




